        a_0             .equr   R1
        a_1             .equr   R2
        a_2             .equr   R3
        a_3             .equr   R4
        a_4             .equr   R5
        a_5             .equr   R6
        a_6             .equr   R7
        d_0             .equr   R8
        d_1             .equr   R9
        d_2             .equr   R10
        d_3             .equr   R11
        d_4             .equr   R12
        d_5             .equr   R13
        d_6             .equr   R21
        d_7             .equr   R25
        G_x_velocity    .equr   R16
        G_y_velocity    .equr   R17
        G_map_width     .equr   R18
        Junk            .equr   R19
        Junk1           .equr   R14
        Junk2           .equr   R20
        G_mapx          .equr   R22
        G_mapy          .equr   R23
        G_shadow_base   .equr   R24
        Junk_dbf        .equr   R26
        S_P             .equr   R27

;*******************
;       JSR Macro
;       Trashes R19
;*******************
        .MACRO  jsr     dest
        subqt   #4,S_P          ; adjust the stack pointer
        nop
        move    PC,Junk         ; determine current program address
        addq    #16,Junk        ; new address for after this macro
        nop
        store   Junk,(S_P)      ; push return address onto stack
        movei   #\dest,Junk     ; load up subroutine address
        jump    (Junk)          ; jump to subroutine
        nop                     ; jump doesn't occur until this instr
        .ENDM

;*******************
;       RTS Macro
;       Trashes R19
;*******************
        .MACRO  rts
        load    (S_P),Junk      ; load up return address
        jump    (Junk)          ; jump back to return address
        addqt   #4,S_P          ; adjust the stack pointer
        .ENDM

;*******************
;       BRA Macro
;       Trashes R19
;*******************
        .MACRO  bra     dest
        movei   #\dest,Junk
        jump    T,(Junk)
        nop
        .ENDM

;*******************
;       BCC Macro
;       Trashes R19
;*******************
        .MACRO  bcc     dest
        movei   #\dest,Junk
        jump    CC,(Junk)
        nop
        .ENDM

;*******************
;       BGT Macro
;       Trashes R19
;*******************
        .MACRO  bgt     dest
        movei   #\dest,Junk
        jump    CC,(Junk)
        nop
        .ENDM

;*******************
;       BCS Macro
;       Trashes R19
;*******************
        .MACRO  bcs     dest
        movei   #\dest,Junk
        jump    CS,(Junk)
        nop
        .ENDM

;*******************
;       BLT Macro
;       Trashes R19
;*******************
        .MACRO  blt     dest
        movei   #\dest,Junk
        jump    CS,(Junk)
        nop
        .ENDM

;*******************
;       BMI Macro
;       Trashes R19
;*******************
        .MACRO  bmi     dest
        movei   #\dest,Junk
        jump    MI,(Junk)
        nop
        .ENDM

;*******************
;       BPL Macro
;       Trashes R19
;*******************
        .MACRO  bpl     dest
        movei   #\dest,Junk
        jump    PL,(Junk)
        nop
        .ENDM

;*******************
;       BHI Macro
;       Trashes R19
;*******************
        .MACRO  bhi     dest
        movei   #\dest,Junk
        jump    HI,(Junk)
        nop
        .ENDM

;*******************
;       BEQ Macro
;       Trashes R19
;*******************
        .MACRO  beq     dest
        movei   #\dest,Junk
        jump    EQ,(Junk)
        nop
        .ENDM

;*******************
;       BNE Macro
;       Trashes R19
;*******************
        .MACRO  bne     dest
        movei   #\dest,Junk
        jump    NE,(Junk)
        nop
        .ENDM

;*******************
;       DBF Macro
;       Trashes R24
;*******************
        .MACRO  dbf     reggie,dest
        movei   #\dest,Junk_dbf
        nop
        subq    #1,\reggie
        jump    PL,(Junk_dbf)
        nop
        .ENDM

;*******************
;       SWAP Macro
;*******************
        .MACRO  swap    reggie
        rorq    #16,\reggie
        .ENDM


;*******************
;       TST   Macro
;*******************
        .MACRO  tst     reggie
        cmpq    #0,\reggie
        .ENDM

